Attribute VB_Name = "TransFX"
'The TransparencyFX Module
'Supports only one form; for more, modify code
'To use:
'
'Call SetFormRgn whenever form is resized
'For each area that is -not- to be transparent, add it:
'
'first use GetRectCoord to get the correct x1,y1,x2,y2
'then using the ret from GetRectCoord, call one of the AddXXX with those values
'
'a bit confusing...see sample
'
'
'Add parameters:
'nMode : draw constant, see below for full info
'
'When areas are done, call RenderForm.
'
'To reset data, call SetFormRgn
'At end, call FreeRegions to prevent memory leaks
'
'Areas must be rendered whenver form is resized

Type POINTAPI
    X As Long
    Y As Long
End Type

Type RECT
    x1 As Long
    y1 As Long
    x2 As Long
    y2 As Long
End Type

Private Declare Function CreateEllipticRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long, ByVal x3 As Long, ByVal y3 As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private xFrm_wid As Long
Private xFrm_hgt As Long
Private xFrm_BWid As Long 'border width
Private xFrm_THgt As Long 'title height

Private xFrm_rgn As Long

'nMode constants
Public Const RGN_AND = 1    'isect(rgn1,rgn2)
Public Const RGN_OR = 2     'rgn1 + rgn2
Public Const RGN_XOR = 3    'RGN_OR - RGN_AND
Public Const RGN_DIFF = 4   'rgn1 - rgn2
Public Const RGN_COPY = 5

Function GetRectCoord(lft&, tp&, wid&, hgt&, frm As Form) As RECT
Dim x1&, y1&, x2&, y2&
Dim rc As RECT
With frm
    x1 = .ScaleX(lft, .ScaleMode, vbPixels) + xFrm_BWid
    y1 = .ScaleX(tp, .ScaleMode, vbPixels) + xFrm_THgt
    x2 = .ScaleX(wid, .ScaleMode, vbPixels) + x1
    y2 = .ScaleX(hgt, .ScaleMode, vbPixels) + y1
End With
With rc
    .x1 = x1
    .y1 = y1
    .x2 = x2
    .y2 = y2
End With
GetRectCoord = rc
End Function

Sub AddPoly(nMode&, ByRef poly() As POINTAPI)
Dim tmp_rgn&
tmp_rgn = CreatePolygonRgn(poly(0), 1 + UBound(poly), 0)
CombineRgn xFrm_rgn, xFrm_rgn, tmp_rgn, nMode
DeleteObject tmp_rgn
End Sub
Sub AddRoundRect(nMode&, x1&, y1&, x2&, y2&, x3&, y3&)
Dim tmp_rgn&
tmp_rgn = CreateRoundRectRgn(x1, y1, x2, y2, x3, y3)
CombineRgn xFrm_rgn, xFrm_rgn, tmp_rgn, nMode
DeleteObject tmp_rgn
End Sub
Sub AddEllipse(nMode&, x1&, y1&, x2&, y2)
Dim tmp_rgn&
tmp_rgn = CreateEllipticRgn(x1, y1, x2, y2)
CombineRgn xFrm_rgn, xFrm_rgn, tmp_rgn, nMode
DeleteObject tmp_rgn
End Sub
Sub AddRect(nMode&, x1&, y1&, x2&, y2)
Dim tmp_rgn&
tmp_rgn = CreateRectRgn(x1, y1, x2, y2)
CombineRgn xFrm_rgn, xFrm_rgn, tmp_rgn, nMode
End Sub
Sub FreeRegions()
'Run this at end of program to free up memory
DeleteObject xFrm_rgn
End Sub

Sub RenderForm(wnd&)
SetWindowRgn wnd, xFrm_rgn, True
End Sub

Sub SetFormRgn(frm As Form)
'Run this whenever the form is resized
Dim outer_rgn As Long
Dim inner_rgn As Long

With frm
    If .WindowState = vbMinimized Then Exit Sub

    'Create the main form region.
    xFrm_wid = .ScaleX(.Width, vbTwips, vbPixels)
    xFrm_hgt = .ScaleY(.Height, vbTwips, vbPixels)
    outer_rgn = CreateRectRgn(0, 0, xFrm_wid, xFrm_hgt)

    xFrm_BWid = (xFrm_wid - .ScaleWidth) / 2
    xFrm_THgt = xFrm_hgt - xFrm_BWid - .ScaleHeight
    inner_rgn = CreateRectRgn(xFrm_BWid, xFrm_THgt, xFrm_wid - xFrm_BWid, xFrm_hgt - xFrm_BWid)

    ' Subtract the inner region from the outer.
    xFrm_rgn = CreateRectRgn(0, 0, 0, 0)
    CombineRgn xFrm_rgn, outer_rgn, inner_rgn, RGN_DIFF
    
    DeleteObject outer_rgn
    DeleteObject inner_rgn
End With
End Sub

